//compilieren mit
// gcc -L/usr/local/lib  mqttCGIPub.c -lmosquitto -o mqttCGIPub.bin -L. -lurlCoding
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "mosquitto.h"
#include "urlcoding.h"

void on_publish(struct mosquitto *mosq, void *userdata, int mid){
  mosquitto_disconnect(mosq);
}

int main(int argc, char *argv[]){

  printf("Content-Type: text/html\n\n");
  printf("<html><body>\n");
  printf("  <h1>Licht in der Garage steuern</h1> \n");
  printf("  <table> \n");
  printf("    <tr> \n");
  printf("      <td> \n");
  printf("	<form method='GET' action='http://mosquitto.wara.de/garLicht.bin'> \n");
  printf("	  <input type='hidden' name='topic' value='licht/garage'/> \n");
  printf("	  <input type='hidden' name='message' value='an'/> \n");
  printf("	  <input type='submit' value='an'/> \n");
  printf("	</form> \n");
  printf("      </td> \n");
  printf("      <td> \n");
  printf("	<form method='GET' action='http://mosquitto.wara.de/garLicht.bin'> \n");
  printf("	  <input type='hidden' name='topic' value='licht/garage'/> \n");
  printf("	  <input type='hidden' name='message' value='aus'/> \n");
  printf("	  <input type='submit' value='aus'/> \n");
  printf("	</form> \n");
  printf("      </td> \n");
  printf("    </tr> \n");

    char encodiert[1024] = {0}; //string wird laenger, z.B. '#' -> %23
  char decodiert[256] = {0};
 
  // wir lesen die umgebungsvariable
  char* queryString = getenv("QUERY_STRING");
  // der QUERY_STRING ist url-encodiert, das machen wir rueckgaengig
  urlDecode(decodiert, queryString);

  // der decodierte QUERY_STRING sieht im beispiel dann so aus:
  // topic=licht/garage&message=an
  
  // d.h. der QUERY_STRING hat ein format wie z.b.:
  // topic=licht/garage&message=an

  // WENN wir voraussetzen, dass der QUERY_STRING immer genau so aufgebaut ist (auf webseite (s.o.) festlegen!)
  // DANN ist:
  // unser topic von den zeichen '=' und '&' begrenzt
  // der message geht immer ein '='-zeichen voran
  // somit koennen wir mit sscanf den QUERY_STRING zerlegen
  
  char topic[256] ;
  char message[256] ;

  // % steht fuer eine zeichensequenz
  // %* steht fuer eine zeichensequenz, die ignoriert wird
  // %c fuer ein einzelnes zeichen, %*c fuer ein einzelnes, zu ignorierendes zeichen
  // %[^=] steht fuer eine zeichensequenz, die kein = enthaelt
  // %s steht fuer eine zeichensequenz beliebiger laenge (also einen string)

  sscanf(decodiert, "%*[^=]%*c%[^&]%*[^=]%*c%s", topic, message);

  // erklaerung:
  // %*[^=] : wir lesen und ignorieren die zeichen, solange kein = kommt
  // %*c    : wir lesen und ignorieren ein einzelnes, weiteres zeichen (das '=')
  // %[^&]  : wir lesen die naechsten zeichen und speichern diese in 'topic' solange kein '&' kommt
  // %*[^=] : wir lesen und ignorieren die zeichen, solange kein = kommt
  // %*c    : wir lesen und ignorieren ein einzelnes, weiteres zeichen (das '=')
  // %s     : wir lesen die restlichen zeichen und speichern diese in  'message'

  //nun wird veroeffentlicht:

  
  printf("</body></html> \n");
  
  return 0;
}
