//hostadresse noch hart-codiert->aendern!!!

//webseite der mosquitto-api
//https://mosquitto.org/api/files/mosquitto-h.html

//compilieren mit
// gcc -L/usr/local/lib  mqttCGIPub.c -lmosquitto -o mqttCGIPub.bin -L. -lurlCoding
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "mosquitto.h"
#include "urlcoding.h"

void on_publish(struct mosquitto *mosq, void *userdata, int mid){
  mosquitto_disconnect(mosq);
}

void relais(char* topic, char* message){
  struct mosquitto *mosq;
  mosq = mosquitto_new("id", true, NULL);
  mosquitto_publish_callback_set(mosq, on_publish);
  mosquitto_connect(mosq, "localhost", 1883, 0); //broker und cgi programm laufen beide auf localhost
  mosquitto_publish(mosq, NULL, topic, 3, message, 0, true);
  mosquitto_loop_forever(mosq, -1, 1);  // this calls mosquitto_loop() in a loop, it will exit once the client disconnects cleanly
}

char* subscribe(char* topic, char* message){
  int rc;
  struct mosquitto_message *msg;

  mosquitto_lib_init();

  rc = mosquitto_subscribe_simple(
				  &msg, 1, true,
				  topic, 0,
				  "localhost", 1883,
				  NULL,
				  60, //mqtt-keepalive-value
				  true,
				  NULL, NULL,
				  NULL, NULL);
  
  if(rc){
    //printf("Error: %s\n", mosquitto_strerror(rc));
    mosquitto_lib_cleanup();
    return "<h1>fehler beim lesen vom broker!</h1>";
  }
 
  strcpy(message, (char *)msg->payload);
  
  //printf("%s %s\n", msg->topic, (char *)msg->payload);
  
  mosquitto_message_free(&msg);
  mosquitto_lib_cleanup();

  //idee: abhaengig vom wert von message (an/aus) koennte man message noch um
  //html-tags ergaenzen, die den string farbig ausgeben
  if(strcmp("an", message)==0){
    return "<span style='color:#FF8C00; font-size:28px'> AN </span>";
  }
  if(strcmp("aus", message)==0){
    return "<span style='color:#00008B; font-size:28px'> AUS </span>";
  }
  else return message;
}



int main(int argc, char *argv[]){

  //mqtt topic (-t) und message (-m)
  char topic[256] ;
  char message[256] ;

  char mqttMessage[256] ;
  
  //char encodiert[1024] = {0}; //string wird laenger, z.B. '#' -> %23
  char decodiert[256] = {0};
 
  // wir lesen die umgebungsvariable
  char* queryString = getenv("QUERY_STRING");
    
  if(queryString == NULL){
    //printf("query_string leer!");
    //nix tun
  }else{
    
  // der QUERY_STRING ist url-encodiert, das machen wir rueckgaengig
  // die funktion urlDecode(char*, char*) steht in der lib urlcoding
  urlDecode(decodiert, queryString);

  //printf("queryString: %s\n", decodiert);
  
  // der decodierte QUERY_STRING sieht im beispiel dann so aus:
  // topic=licht/garage&message=an
  
  // d.h. der QUERY_STRING hat ein format wie z.b.:
  // topic=licht/garage&message=an

  // WENN wir voraussetzen, dass der QUERY_STRING immer genau so aufgebaut ist (auf webseite (s.o.) festlegen!)
  // DANN ist:
  // unser topic von den zeichen '=' und '&' begrenzt
  // der message geht immer ein '='-zeichen voran
  // somit koennen wir mit sscanf den QUERY_STRING zerlegen

  // % steht fuer eine zeichensequenz
  // %* steht fuer eine zeichensequenz, die ignoriert wird
  // %c fuer ein einzelnes zeichen, %*c fuer ein einzelnes, zu ignorierendes zeichen
  // %[^=] steht fuer eine zeichensequenz, die kein = enthaelt
  // %s steht fuer eine zeichensequenz beliebiger laenge (also einen string)

  sscanf(decodiert, "%*[^=]%*c%[^&]%*[^=]%*c%s", topic, message);

  // erklaerung:
  // %*[^=] : wir lesen und ignorieren die zeichen, solange kein = kommt
  // %*c    : wir lesen und ignorieren ein einzelnes, weiteres zeichen (das '=')
  // %[^&]  : wir lesen die naechsten zeichen und speichern diese in 'topic' solange kein '&' kommt
  // %*[^=] : wir lesen und ignorieren die zeichen, solange kein = kommt
  // %*c    : wir lesen und ignorieren ein einzelnes, weiteres zeichen (das '=')
  // %s     : wir lesen die restlichen zeichen und speichern diese in  'message'

  //nun koennen wir den zustand des relais setzen:

  if(strcmp(message, "aus")== 0 || strcmp(message, "an")==0){
    relais(topic, message);
  }
  
  //printf("query_string: %s\n", decodiert);

  //printf("topic: %s\n", topic);
  //printf("message: %s\n", message);
  
  //printf("<h1>CGI: publish</h1>\n");
  //printf("<p>das cgi-programm sendet eine Meldung an den \n");
  //printf("mqtt-broker. das thema (topic) und die meldung (message) werden mit hidden-fields in einem webformular gesetzt.</p>\n");
  
  }//else auf test ob QUERY_STRING leer ist

  printf("Content-Type: text/html\n\n");
  printf("<html><body> \n");
  printf("  <h1>Licht in der Garage schalten</h1> \n");

  //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
  printf("  <h3> jetzt ist das licht %s </h3>", subscribe("garage/licht-rel4", mqttMessage));
  //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  printf("  <table> \n");
  printf("    <tr> \n");
  printf("      <td> \n");
  printf("	<form method='GET' action='http://mosquitto.wara.de/garLicht.bin'> \n");
  printf("	  <input type='hidden' name='topic' value='garage/licht-rel4'/> \n");
  printf("	  <input type='hidden' name='message' value='an'/> \n");
  printf("	  <input type='submit' value='an'/> \n");
  printf("	</form> \n");
  printf("      </td> \n");
  printf("      <td> \n");
  printf("	<form method='GET' action='http://mosquitto.wara.de/garLicht.bin'> \n");
  printf("	  <input type='hidden' name='topic' value='garage/licht-rel4'/> \n");
  printf("	  <input type='hidden' name='message' value='aus'/> \n");
  printf("	  <input type='submit' value='aus'/> \n");
  printf("	</form> \n");
  printf("      </td> \n");
  printf("      <td> \n");
  printf("	<form method='GET' action='http://mosquitto.wara.de/garLicht.bin'> \n");
  //  printf("	  <input type='hidden' name='topic' value='licht/garage'/> \n");
  //  printf("	  <input type='hidden' name='message' value='aus'/> \n");
  printf("	  <input type='submit' value='status'/> \n");
  printf("	</form> \n");
  printf("      </td> \n");
  printf("    </tr></table> \n");
  printf("<p> \n");
  printf("  <h1>Raumtemperaturen abfragen</h1> \n");
  printf("  <form method='GET' action='http://mosquitto.wara.de/garLicht.bin'> \n");
  //printf("     <label> Temperaturen: \n");
  printf("        <select name='topic' size='4'> \n");
  printf("           <option selected='selected'>temp/az</option> \n");
  printf("           <option>temp/bad</option> \n");
  printf("           <option>temp/garage</option> \n");
  printf("           <option>temp/wz</option> \n");
  // das auswahl-formular laedt die beiden felder topic und message hoch
  // beim holen eines werts vom broker benoetigt man natuerlich keine message
  // die dient hier nur dazu, damit der supersimple QUERY_STRING-parser funktioniert
  // und mit dem wert von message kann man dann im programm mit strcmp(...) die gewuenschte aktion auswaehlen
  printf("	     <input type='hidden' name='message' value='tempMessen'/><br/> \n");
  printf(" <br/>\n");
  printf("	     <input type='submit' value='Temperatur messen'/> \n");
  printf("        </select> \n");
  //printf("     </label> \n");
  printf("  </form> \n");
  printf("</p> \n");
  printf("<p> \n");
  
  //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  if(strcmp(message, "tempMessen")==0){
    printf("<h3>%s : %s </h3>\n", topic, subscribe(topic, message));
  }else {
    //printf("message hat den wert: %s\n", message);
  }
  //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  printf("</p> \n");

  //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% garagentor %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
  printf("  <h1>Garagentor steuern</h1> \n");

  printf("  <table> \n");
  
  //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% torAuf-rel1  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  printf("<tr><th/><th/><th>relaisStatus</th></tr>");
  printf("    <tr> \n");
  printf("      <td> \n");
  printf("	<form method='GET' action='http://mosquitto.wara.de/garLicht.bin'> \n");
  printf("	  <input type='hidden' name='topic' value='garage/torAuf-rel1'/> \n");
  printf("	  <input type='hidden' name='message' value='an'/> \n");
  printf("	  <input type='submit' value='Tor auf'/> \n");
  printf("	</form> \n");
  printf("      </td> \n");
  printf("      <td> \n");
  printf("	<form method='GET' action='http://mosquitto.wara.de/garLicht.bin'> \n");
  printf("	  <input type='hidden' name='topic' value='garage/torAuf-rel1'/> \n");
  printf("	  <input type='hidden' name='message' value='aus'/> \n");
  printf("	  <input type='submit' value='Stopp'/> \n");
  printf("	</form> \n");
  printf("      </td> \n");
  printf("      <td> \n");
  printf("%s\n", subscribe("garage/torAuf-rel1", mqttMessage));
  printf("      </td> \n");
  printf("    </tr> \n");
  //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% torAb-rel2  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  printf("    <tr> \n");
  printf("      <td> \n");
  printf("	<form method='GET' action='http://mosquitto.wara.de/garLicht.bin'> \n");
  printf("	  <input type='hidden' name='topic' value='garage/torAb-rel2'/> \n");
  printf("	  <input type='hidden' name='message' value='an'/> \n");
  printf("	  <input type='submit' value='Tor ab'/> \n");
  printf("	</form> \n");
  printf("      </td> \n");
  printf("      <td> \n");
  printf("	<form method='GET' action='http://mosquitto.wara.de/garLicht.bin'> \n");
  printf("	  <input type='hidden' name='topic' value='garage/torAb-rel2'/> \n");
  printf("	  <input type='hidden' name='message' value='aus'/> \n");
  printf("	  <input type='submit' value='Stopp'/> \n");
  printf("	</form> \n");
  printf("      </td> \n");
  printf("      <td> \n");
  printf("%s\n", subscribe("garage/torAb-rel2", mqttMessage));
  printf("      </td> \n");
  printf("    </tr> \n");
  //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% torRiegel-rel3  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  printf("    <tr> \n");
  printf("      <td> \n");
  printf("	<form method='GET' action='http://mosquitto.wara.de/garLicht.bin'> \n");
  printf("	  <input type='hidden' name='topic' value='garage/torRiegel-rel3'/> \n");
  printf("	  <input type='hidden' name='message' value='an'/> \n");
  printf("	  <input type='submit' value='Torriegel &ouml;ffnen'/> \n");
  printf("	</form> \n");
  printf("      </td> \n");
  printf("      <td> \n");
  printf("	<form method='GET' action='http://mosquitto.wara.de/garLicht.bin'> \n");
  printf("	  <input type='hidden' name='topic' value='garage/torRiegel-rel3'/> \n");
  printf("	  <input type='hidden' name='message' value='aus'/> \n");
  printf("	  <input type='submit' value='Torriegel schliessen'/> \n");
  printf("	</form> \n");
  printf("      </td> \n");
  printf("      <td> \n");
  printf("%s\n", subscribe("garage/torRiegel-rel3", mqttMessage));
  printf("      </td> \n");

  printf("    </tr> \n");
  //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  printf("    <tr> \n");
  printf("      <td> \n");
  printf("	<form method='GET' action='http://mosquitto.wara.de/garLicht.bin'> \n");
  //  printf("	  <input type='hidden' name='topic' value='licht/garage'/> \n");
  //  printf("	  <input type='hidden' name='message' value='aus'/> \n");
  printf("	  <input type='submit' value='status'/> \n");
  printf("	</form> \n");
  printf("      </td> \n");
  printf("    </tr></table> \n");
  
  printf(" \n");
  printf("</body></html>");

  return 0;
}


