#include <stdio.h>
#include <ctype.h>

char table[256] = {0};

//eigentliche funktion, die das url-encoding erledigt
char* urlEncode(unsigned char *s, char *enc){
  
  for (; *s; s++){

    if (table[*s]) sprintf( enc, "%c", table[*s]);
    else sprintf( enc, "%%%02X", *s);
    while (*++enc);
  }

  return( enc);
}

//funktion, die url-encoding nach RFC3986 erledigt
char* urlEncodeRfc3986(unsigned char *s, char *enc){

  //codtabelle initialisieren
  int i;
  for (i = 0; i < 256; i++){
    table[i] = isalnum( i) || i == '~' || i == '-' || i == '.' || i == '_' ? i : 0;
  }
  
  return( urlEncode(s, enc));
}

//funktion, die url-encoding fuer HTML5 erledigt
char* urlEncodeHtml5(unsigned char *s, char *enc){

  //codtabelle initialisieren
  int i;
  for (i = 0; i < 256; i++){
    table[i] = isalnum( i) || i == '*' || i == '-' || i == '.' || i == '_' ? i : (i == ' ') ? '+' : 0;
  }
  
  return( urlEncode(s, enc));
}

//funktion fuer das url-decoding
void urlDecode(char *dst, const char *src){
  char a, b;
  while (*src) {
    if ((*src == '%') &&
	((a = src[1]) && (b = src[2])) &&
	(isxdigit(a) && isxdigit(b))) {
      if (a >= 'a')
	a -= 'a'-'A';
      if (a >= 'A')
	a -= ('A' - 10);
      else
	a -= '0';
      if (b >= 'a')
	b -= 'a'-'A';
      if (b >= 'A')
	b -= ('A' - 10);
      else
	b -= '0';
      *dst++ = 16*a+b;
      src+=3;
    } else if (*src == '+') {
      *dst++ = ' ';
      src++;
    } else {
      *dst++ = *src++;
    }
  }
  *dst++ = '\0';
}
